#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\..\Icon\Titto\Twitter.ico
#AutoIt3Wrapper_Outfile=lse-procwatch.exe
#AutoIt3Wrapper_Res_Fileversion=0.0.0.7
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Array.au3>


$ProcList = ProcessList(@ScriptName)
If $ProcList[0][0] > 1 Then
	Exit
EndIf

FileDelete(@ScriptDir & "\" & @ScriptName & ".log")
LogWrite("Started: """ & $CmdLineRaw & """ -> " & _ArrayToString($CmdLine))

$CsDetected = False
While WinExists("[CLASS:TRACERSHIP32]")
	If Not $CsDetected Then
		LogWrite("Clippership window detected.")
		$CsDetected = True
	EndIf
	Sleep(100)
WEnd

If $CsDetected Then
	LogWrite("Clippership window closed.")
Else
	LogWrite("Clippership window not found, exiting.")
	Exit
EndIf

$i = 1
$Timer = TimerInit()
$Elapsed = 0
$ProgOn = False
While $Elapsed < 8000 And $i <= $CmdLine[0]
	If Not ProcessExists($CmdLine[$i]) Then
		LogWrite($CmdLine[$i] & " (" & $i & ") is not running, skip to next.")

		$i = $i + 1
		ContinueLoop
	EndIf

	Sleep(100)

	$Elapsed = TimerDiff($Timer)
	If $Elapsed > 3000 And Not $ProgOn Then
		$ProgOn = True
		ProgressOn("", "Waiting for processes to complete...", $CmdLine[$i])
		LogWrite($CmdLine[$i] & " (" & $i & ") is running, wait...")
	EndIf

	If $ProgOn Then
		ProgressSet((($Elapsed - 3000) / 5000) * 100)
	EndIf
WEnd
LogWrite("Done waiting.")
ProgressOff()

For $j = $i To $CmdLine[0]
	$ProcList = ProcessList($CmdLine[$i])

	For $k = 1 To $ProcList[0][0]
		MsgBox(64, "", "Closing " & $ProcList[$k][0], 0.5)
		LogWrite("Closing " & $ProcList[$k][0] & "|" & $ProcList[$k][1] & " (" & $i & ").")
		ProcessClose($ProcList[$k][1])
		Sleep(100)
	Next
Next
LogWrite(@ScriptName & " exit.")

Func LogWrite($logTxt)
	For $i = 1 To 31
		$logTxt = StringReplace($logTxt, Chr($i), "")
	Next

	If StringRight($logTxt, 1) <> "." Then
		$logTxt &= "."
	EndIf

	Dim $logTime
	$logTime = @MON & "/" & @MDAY & "/" &  @YEAR & " " & @HOUR & ":" & @MIN & ":" & @SEC & "." & @MSEC

	ConsoleWrite($logTime & " " & $logTxt & @LF)
	FileWriteLine(@ScriptDir & "\" & @ScriptName & ".log", $logTime & " " & $logTxt)
EndFunc
